This is an extension and not part of the main GoJS library. Note that the API for this class may change at any time. If you intend to use an extension in production, you should copy the code to your own source directory. Extensions can be found in the GoJS kit under the `extensions` or `extensionsTS` folders. See the Extensions intro page for more information.

### Hierarchy

- Tool
  - DragSelectingTool
    - RealtimeDragSelectingTool

The RealtimeDragSelectingTool class lets the user select and deselect Parts within the DragSelectingTool.box during a drag, not just at the end of the drag.

If you want to experiment with this extension, try the Realtime Drag Selecting sample.

## Index

### Methods

- doActivate
- doCancel
- doDeactivate
- doKeyDown
- doKeyUp
- doMouseMove
- selectInRect

## Methods

### Override doActivate

- doActivate(): void

- Remember the original collection of selected Parts.

  #### Returns void

### Override doCancel

- doCancel(): void

- Restore the selection which may have been modified during a drag.

  #### Returns void

### Override doDeactivate

- doDeactivate(): void

- Release any references to selected Parts.

  #### Returns void

### Override doKeyDown

- doKeyDown(): void

- Select Parts within the bounds of the drag-select box.

  #### Returns void

### Override doKeyUp

- doKeyUp(): void

- Select Parts within the bounds of the drag-select box.

  #### Returns void

### Override doMouseMove

- doMouseMove(): void

- Select Parts within the bounds of the drag-select box.

  #### Returns void

### Override selectInRect

- selectInRect(r: Rect): void

- For a given rectangle, select Parts that are within that rectangle.

  #### Parameters

  - ##### r: Rect

    rectangular bounds in document coordinates.

  #### Returns void

Copyright © 1998-2019 by Northwoods Software Corporation.